; rs232.inc
; 楤 ࠡ  ⮬ RS232  ZX_MCard
;------------------------------------------------
SER_P	equ	0F8EFh	; RS232  쥢
P_KBD	equ	0FEh	;  㬠
;------------------------------------------------
;	।  (A)
; CY=0 । ᯥ譠
; CY=1 室  <BREAK>
tx_byte:PUSH	BC
	LD	C,A	;  ।
;/-----
sen1byt:CALL	tst_tx	   ;⮢  । ?
	JR	NZ,sen2byt ; 
; ஢ ⨥  <BREAK>
	CALL	tst_brk	   ;CY=1 ᫨ 
	jr	nc,sen1byt ;  㯮
; 室   <BREAK>
	POP	BC	   ;CY=1,Z=0
	RET
;\-----
;	।稪 ⮢
sen2byt:LD	A,C	; 
	CALL	dat_ou	;।  (A)
	OR	A	;CY=0 OK
	POP	BC
	RET
;---------------------------------------------------------
; tx_ack - wait until the line is clear (i.e. we time out
;	   while receiving chars), and then send an <ack>
;---------------------------------------------------------
tx_ack:	call	rx_t1		; get a char, with 1 second timeout
	jr	nc,tx_ack	; if no timeout, keep gobbling chars
; ⥪ ⠩-
	ld	a,ack		; <ack> char
	jr	tx_byte		; send it
;---------------------------------------------------------
; tx_nak - wait until the line is clear (i.e. we time out
;	   while receiving chars), and then send a <nak>
;---------------------------------------------------------
tx_nak:	call	rx_t1		; get a char, with 1 second timeout
	jr	nc,tx_nak	; if no timeout, keep gobbling chars
; ⥪ ⠩-
	ld	a,nak		; <nak> char
	jr	tx_byte		; send it
;---------------------------------------------
; ਥ  ⠩-⮬  1 ᥪ
rx_t10:	push	DE
	ld	DE,0000h	; 1 ᥪ
	jr	rec_b3
;-------------------------
; ਭ   ⠩-⮬  0.1 ᥪ
;	CY=0	ਥ OK
;	CY=1 	⥪ ⠩-
rx_t1:	PUSH	DE
	LD	DE,2000h  	;⠩-
;/-----
rec_b3:	CALL	tst_rx	  	;⮢ ਥ
	JR	NZ,rec_b2	; ⮢
;
	DEC	DE
	LD	A,D
	OR	E
	JR	NZ,rec_b3
; ⥪ ⠩-
	scf			;CY=1 - ਧ ⠩-
	pop	de
	ret
rec_b2:	call	dat_in		;ਭ 
	or	a		;CY=0 - ਧ OK
	pop	de
	ret
;---------------------------------
;------   ⠬ ---------
;---------------------------------
; ਭ    RS232
dat_in:	PUSH	BC
	LD	BC,SER_P	; 
	IN	A,(C)
	POP	BC
	RET
;==============================
; ।    RS232
dat_ou:	PUSH	BC
	LD	BC,SER_P
	OUT	(C),A
	POP	BC
	RET
;==============================
; ஢  祭 
tst_rx:	PUSH	BC
	LD	BC,SER_P+5*100h ;⥭ (base+5)
	IN	A,(C)		;
	AND	01h		;RDY_RX(0)
	POP	BC
	RET
;=====================================
; ஢  ⮢ ।
tst_tx:	PUSH	BC
	LD	BC,SER_P+6*100h
	IN	A,(C)		;(base+6)
	and	10h		;CTS ?
	JR	Z,no_tx		; ⮢
; ஢ Bufer ।稪
	DEC	B		;BC=SER_P+5*100h
	IN	A,(C)		;(base+5)
	and	20h		;Bufer empty ?
no_tx:	POP	BC
	RET
;============================
res_rts:PUSH	BC
	LD	BC,SER_P+4*100h
	LD	A,01h		;RTS=0,DTR=1
	jr	set_reg
;============================
set_rts:push	bc
	ld	bc,SER_P+4*100h
	ld	a,03h		;RTS=1,DTR=1
set_reg:OUT	(C),A
	POP	BC
	RET
;-----------------------------------------------
;  ᫨  <BREAK-KEY>
;	C=1, A=0FFh
tst_brk:LD	A,7Fh		; A15=0
	IN	A,(P_KBD)	; 
	RRA			; d0=?
	jr	c,tst1brk	;  <CAPS SHIFT>
;   <CAPS SHIFT>
	LD	A,0FEh		; a8=0
	IN	A,(P_KBD)	; 
	RRA			; d0=?
; C=0	+   <SPACE>
	jr	c,tst1brk	;  <SPACE>
	xor	a
	dec	a		;Z=0, CY=0
tst1brk:ccf			;  CY
	RET			;
; C=1 +   <SPACE>
;--------------------------------------------
; end rs232.inc
